<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\User;
use DB, Auth, Hash, Session;
use Redirect;

class AuthController extends Controller{

    public function login(Request $request){
        return view('auth.login');
    }

    public function authentication(Request $request){
        $request->validate([
            'email' => 'required',
            'password' => 'required',
        ]);

        try{
            $credentials = $request->only('email', 'password');
            if(Auth::attempt($credentials)) {
                $user = Auth::user();
                Session::push('admin_logged_in', $user);
                Session::save();
                return redirect()->route('dashboard')->with('success','Your have successfuly Logged in!');
            }
    
            return redirect()->route('login')->with('failed','Invalid Login Id or password!');
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return redirect()->back()->with('error', $e->errorMessage());
        }
    }

    public function signOut() {
        Session::flush();
        Auth::logout();
        return Redirect('/');
    }
}
