<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use CurlFile;
use Log;
use Carbon\Carbon;
use App\Models\Audios;
use App\Models\CompareAudios;
use App\Models\CompareAudiosList;
use DB;
class VoiceController extends Controller
{
    
    public function __construct() {
        $this->baseurl = 'http://7d78-34-66-107-200.ngrok.io/';
    }

    public function dashboard(Request $request){
        $uploadSplitAudio = Audios::where(['type'=>1,'status'=>1])->get();
        $uploadCompareAudio = Audios::where(['type'=>2,'status'=>1])->get();
        $CompareAudios = CompareAudios::where(['status'=>1])->orderBy('id','DESC')->limit(5)->get();
        $CompareAudiosInWeek = CompareAudios::where(['status'=>1])->whereBetween('created_at', [Carbon::now()->startOfWeek(), Carbon::now()->endOfWeek()])->get();
        $MatchedCompareAudios = CompareAudios::where(['status'=>1])->get();
        $MatchedCompareAudioscount = 0;
        foreach($MatchedCompareAudios as $MatchedCompareAudio){
            $MatchedCompareAudioscount += $MatchedCompareAudio->no_matched;
        }
        $recentsearchs = CompareAudiosList::where(['type' => 2])->orderBy('id','DESC')->limit(5)->get();
        $data = (object) [
            'uploadSplitAudio' => count($uploadSplitAudio),
            'uploadCompareAudio' => count($uploadCompareAudio),
            'MatchedCompareAudioscount' => $MatchedCompareAudioscount,
            'CompareAudios' => $CompareAudios,
            'CompareAudiosInWeek' => count($CompareAudiosInWeek),
        ];
        return view('dashboard',compact('uploadSplitAudio','CompareAudios','data','recentsearchs'));
    }

    public function audioListing(Request $request){
        return view('audio_listing');
    }
    
    public function audioListingData(Request $request){
        try {
            $url = $this->baseurl.'listing';    
            // Log::info(print_r($url, true));     

            // Set handle
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,$url);
            // Set options
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            // Execute curl handle add results to data return array.
            $result = curl_exec($ch);
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_decode(['key' => false, 'message' => $error_msg]);
            }else{
                //Log::info(print_r($result, true));                      
                $listresult = json_decode($result);
                // dd($listresult->response);
                return view('audio_listing_data', compact('listresult'));
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return json_decode(['key' => false, 'message' => $e->errorMessage()]);
        }
    }

    public function compare(Request $request){
        return view('compare');
    }

    public function compareSaveFile(Request $request){
        // dd($request->all());
        try{
            $file = $request->file;
            $postdata           = array(
                'file'         =>  new CurlFile($file),
                'sample_rate'   =>  16
            );                    
            // Log::info(print_r($postdata, true).' postdata');
            $headers    =   array(
                // "accessToken: ".$access_token
                'Content-Type' =>  'audio/mpeg',
            );                               
            $url = $this->baseurl.'upload/'.$postdata['sample_rate'];    
            Log::info(print_r($url, true));                 
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,$url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: multipart/form-data"));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);                
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);       
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_encode(['key' => false, 'message' => $error_msg]);
            }else{
                //Log::info(print_r($result, true));  
                $decode_result = json_decode($result); 
                Audios::create([
                    'audio_file' => $decode_result->response,
                    'type' => 2,
                    'response' => $result,
                    'status' => 1,
                ]);                   
                return $decode_result;
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return json_encode(['key' => false, 'message' => $e->getMessage()]);
        }
    }

    public function compareSaveFileData(Request $request){
        // dd($request->all());
        try{
            $postdata   = array(
                'n_speaker'     =>  (int) $request->n_speaker,
                'sample_rate'   =>  (int) $request->sample_rate,
                'threshold'   => $request->threshold,
            );  
            $postjsondata = json_encode($postdata);            
            // Log::info(print_r($postjsondata, true).' postdata');
            $headers    =   array(
                // "accessToken: ".$access_token
                'Content-Type' =>  'multipart/form-data',
            );                               
            $url = $this->baseurl.'test'; ///'.$postdata['n_speaker'].'/'.$postdata['sample_rate'].'/'.$postdata['threshold']    
            Log::info(print_r($url, true));

            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,$url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: multipart/form-data"));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);                
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);       
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_encode(['key' => false, 'message' => $error_msg]);
            }else{
                // Log::info(print_r($result, true)); 
                $resultdata = json_decode($result); //$decode_result->response
                if(isset($resultdata->response)){
                    DB::beginTransaction();
                    $CompareAudios = CompareAudios::create([
                        'no_matched' => $resultdata->no_matched,
                        'response' => $result,
                        'status' => 1,
                    ])->id;
                    if($CompareAudios > 0){
                        foreach($resultdata->response as $rkey => $responsedata){
                            // dd($resultdata->response);
                            Log::info(print_r($resultdata->response, true)); 
                            if(isset($responsedata->matched)){
                                $matcheddata = [
                                    'compare_audios_id' => $CompareAudios,
                                    'matched_audio' => $responsedata->matched->audio,
                                    'matched_email' => $responsedata->matched->email,
                                    'matched_name'  => $responsedata->matched->name,
                                    'matched_percentage' => round($responsedata->matched->percentage),
                                    'type' => 1,
                                    'key_value' => $rkey
                                ];
                                // CompareAudiosList::create();
                                $matchedied = DB::table('compare_audios_list')->insertGetId($matcheddata);
                                CompareAudiosList::where('id', $matchedied)->update(['subject_audio' => $responsedata->subject_audio]);
                            }

                            if(isset($responsedata->other_matched)){
                                foreach($responsedata->other_matched as $mkey => $other_matched){
                                    $matchedother_data = [
                                        'compare_audios_id' => $CompareAudios,
                                        'other_matched_audio' => $other_matched->audio,
                                        'other_matched_email' => $other_matched->email,
                                        'other_matched_name' => $other_matched->name,
                                        'other_matched_percentage' => round($other_matched->percentage),
                                        'type' => 2,
                                        'key_value' => $rkey
                                    ];
                                    $matchedid = DB::table('compare_audios_list')->insertGetId($matchedother_data);
                                    CompareAudiosList::where('id', $matchedid)->update(['subject_audio' => $responsedata->subject_audio]);
                                }
                            }
                        }
                    }
                    DB::commit();
                }
                return view('compare_result', compact('resultdata'));
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            DB::rollback();
            return json_encode(['key' => false, 'message' => $e->getMessage()]);
        }
    }

    public function splitAudio(Request $request){
        return view('split-audio');
    }

    public function splitAudioSaveFile(Request $request){
        // dd($request->all());
        try{
            $file = $request->file;
            $postdata           = array(
                'file'         =>  new CurlFile($file),
                'sample_rate'   =>  16
            );                    
            // Log::info(print_r($postdata, true).' postdata');
            $headers    =   array(
                // "accessToken: ".$access_token
                'Content-Type' =>  'audio/mpeg',
            );                               
            $url = $this->baseurl.'upload/'.$postdata['sample_rate'];    
            Log::info(print_r($url, true));                 
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,$url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: multipart/form-data"));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);                
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);       
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_encode(['key' => false, 'message' => $error_msg]);
            }else{
                Log::info(print_r($result, true)); 
                $dd = json_decode($result);  
                // dd($decode_result);
                Log::info(print_r($dd, true)); 
                Log::info(print_r($dd->response, true)); 
                Audios::create([
                    'audio_file' => $dd->response,
                    'type' => 1,
                    'response' => $result,
                    'status' => 1,
                ]);                   
                return json_decode($result);
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return json_encode(['key' => false, 'message' => $e->getMessage()]);
        }
    }
    
    public function splitAudioSaveFileData(Request $request){
        // dd($request->all());
        try{
            $postdata   = array(
                'n_speaker'     =>  (int) $request->n_speaker,
                'sample_rate'   =>  (int) $request->sample_rate,
            );  
            $postjsondata = json_encode($postdata);            
            Log::info(print_r($postjsondata, true).' postdata');
            $headers    =   array(
                // "accessToken: ".$access_token
                'Content-Type' =>  'multipart/form-data',
            );                               
            $url = $this->baseurl.'generate';    
            Log::info(print_r($url, true));

            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,$url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: multipart/form-data"));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);                
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);       
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_encode(['key' => false, 'message' => $error_msg]);
            }else{
                // Log::info(print_r($result, true));                      
                $resultdata = json_decode($result);
                return view('split-audio_result', compact('resultdata'));
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return json_encode(['key' => false, 'message' => $e->getMessage()]);
        }
    }
    
    public function splitAudioResultSaveData(Request $request){
        // dd($request->all());
        try{
            $postdata   = array(
                'names'    =>  $request->names,
                'emails'   =>  $request->emails,
            );  
            $postjsondata = json_encode($postdata);            
            // Log::info(print_r($postjsondata, true).' postdata');
            $headers    =   array(
                // "accessToken: ".$access_token
                'Content-Type: application/json',
                // 'Content-Length: '.strlen($postjsondata)
            );
            // dd('headers', $headers, 'postjsondata', $postjsondata);               
            $url = $this->baseurl.'register';    
            // Log::info(print_r($url, true));

            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLINFO_HEADER_OUT, true);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postjsondata);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);       
            if(curl_errno($ch)) {
                $error_msg = curl_error($ch);
            }
            curl_close($ch);
            if(isset($error_msg)) {
                return json_encode(['key' => false, 'message' => $error_msg]);
            }else{
                //Log::info(print_r($result, true));                      
                return $decode_result = json_decode($result);
            }
        }catch (\Exception $e) {
            // dd($e->getMessage());
            return json_encode(['key' => false, 'message' => $e->getMessage()]);
        }
    }
}
