<?php

namespace App\Http\Middleware;
use App\Models\User;
use Route;
use Redirect;
use Closure;
use Session;
use Illuminate\Http\Request;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\VoiceController;
class CustomAuth
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        if( Route::currentRouteName() != "login" && Route::currentRouteName() != "login-check" && Route::currentRouteName() != 'logout' && Route::currentRouteName() != 'view-cms-json-list')
            { 
                $input      = $request->all();
                $session    = Session::all();
                $token      = (isset($session['admin_logged_in'][0]['id']) ? $session['admin_logged_in'][0]['id'] : ""); 
              
                // If user is set                
                if(!empty($token))
                {
                    //If user is not found

                    if(! $user= User::where('id', $token )->first())
                    {
                        $message = [                            
                            'msg' => 'Token expired! Please login to continue!',
                            ];
                        return Redirect::action('App\Http\Controllers\AuthController@login')->withErrors($message);
                    }else{

                        
                    }
                }

                // If user is not set
                else{
                    $message = ['msg' => 'Please Login first '  ];

                    return redirect()->action('App\Http\Controllers\AuthController@login');
                    //return Redirect::action('AuthController@login')->withErrors($message);
                                            
                }               

            }

        $response = $next($request);
        
        $response->headers->set('Referrer-Policy', 'no-referrer-when-downgrade');
        $response->headers->set('X-Content-Type-Options', 'nosniff');
        $response->headers->set('X-XSS-Protection', '1; mode=block');
        $response->headers->set('X-Frame-Options', 'DENY');
        $response->headers->set('Strict-Transport-Security', 'max-age:31536000; includeSubDomains');
        return $response;
    }
}
