@extends('app')

@section('content')
    <div class="section">
        <h2 class="fs-24 tss-m-sbold">Compare</h2>
        <div class="row">
            <div class="col-lg-8">
                <div class="boxed p-4 bg-white h-100 d-flex align-items-center">
                    <div class="row align-items-center w-100">
                        <div class="col-lg-6">
                            {{-- <div class="w-100 tss-attachment text-center">
                                <input type="file" class="tss-custom-file-input w-100">
                                <div class="icon">
                                    <i class="fa fa-paperclip" aria-hidden="true"></i>
                                    <span class="tss-m-bold fs-14">Upload</span>
                                </div>
                                <p class="fs-12 text-gray mb-0 py-2">Upload Audio file</p>
                            </div> --}}

                            <div class="w-100 tss-attachment text-center">
                                <input type="file" class="tss-custom-file-input w-100 fUpload" id="fUpload" accept=".mp3,.wav,.ogg,.mpeg,.aac" name="file">
                                <div class="icon">
                                    <i class="fa fa-paperclip" aria-hidden="true"></i>
                                    <span class="tss-m-bold fs-14">Upload</span>
                                </div>
                                <p class="fs-12 text-gray mb-0 py-2">Upload Audio file</p>
                            </div>

                            <div class="note text-center fs-12 py-2"><span class="text-gray">*Max 50MB file should be uploaded</span></div>
                        </div>
                        <div class="col-lg-6">

                            <div class="progress mb-4" style="height: 0.5rem;">
                                <div class="progress-bar" id="upload_progress_bar" role="progressbar" style="width:0%" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100"></div>
                            </div>
                            
                            <p class="fs-18 mb-1">Uploaded file:</p>
                            <p class="fs-18 tss-m-bold" id="filename"></p>
                            <p class="fs-16 text-gray tss-m-sbold"><span id="fileformat"></span> file</p>
                        </div>

                        <div id="uploadfileStatusMessage" class="col-md-12"></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="boxed p-4 bg-white h-100">
                    <form method="POST" action="javascript:0;" id="CompareAudioForm">
                        @csrf
                        <input name="sample_rate" value="16" type="hidden" />
                        <div class="mb-3">
                            <label for="exampleFormControlInput1" class="form-label">Number of Speaker</label>
                            <select class="form-select" name="n_speaker" aria-label="Default select example" required>
                                <option value="" disabled>Select Number of Speaker</option>
                                <option value="2" selected>2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                            </select>
                        </div>    
                        <div class="mb-3">
                            <label for="exampleFormControlInput1" class="form-label">Threshold Value</label>
                            <span class="fs-12 text-gray">(Similarity acceptance)</span>
                            <select class="form-select" name="threshold" aria-label="Default select example" required>
                                <option value="" disabled>Select Threshold Value</option>
                                <option value="0.8" selected>0.8</option>
                                <option value="1">1</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                            </select>
                        </div>
                        <div class="">
                            <div class="d-grid gap-2">
                                <button class="btn tss-btn-primary icon-btn px-4" id="GetSplittedAudioBtn" type="submit" disabled>
                                    <span class="fs-18 tss-m-bold" id="GetSplittedAudioBtnSpan">Compare</span>
                                    <i class="fa fa-arrow-right" aria-hidden="true"></i>    
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div id="CompareResultDiv"></div>
@endsection
@section('script')
<script type="text/javascript">
    $(document).ready(function(){
        // alert("+++++++++++");
        $(document).on('change','#fUpload',function(){
            var property = document.getElementById('fUpload').files[0];
            var image_name = property.name;
            var image_extension = image_name.split('.').pop().toLowerCase();
            var percentage = '0';
            if(jQuery.inArray(image_extension,['mp3','wav','org','wav','mpeg','aac']) == -1){
                alert("Invalid audio file!");
                return;
            }

            setTimeout(function(){
                $('#upload_progress_bar').css("width", '30%', function() {
                    return $(this).attr("aria-valuenow", 30) + "%";
                });
            }, 3000);

            var form_data = new FormData();
            form_data.append("file", property);
            form_data.append("_token", '{{csrf_token()}}');
            $.ajaxSetup({
                header:$('meta[name="_token"]').attr('content')
            })
            $("#GetSplittedAudioBtn").attr('disabled','disabled');
            $(".loaderContainer").show();
            // console.log(form_data);
            $.ajax({
                url: "{{route('compare.save.file')}}",
                method:'POST',
                data:form_data,
                contentType:false,
                cache:false,
                processData:false,
                beforeSend:function(){
                    setTimeout(function(){ 
                        $('#upload_progress_bar').css("width", '75%', function() {
                            return $(this).attr("aria-valuenow", 75) + "%";
                        });
                    }, 6000);
                },
                success:function(data){
                    console.log('data');
                    $(".loaderContainer").hide();
                    if(data.success == 1){
                        // console.log(data);
                        $("#GetSplittedAudioBtn").removeAttr('disabled');
                        $("#uploadfileStatusMessage").text(data.message).addClass('alert_message');
                        setInterval(() => {
                            $("#uploadfileStatusMessage").removeClass('alert_message');
                            $("#uploadfileStatusMessage").text('');
                        }, 3000);
                    }
                    $('#upload_progress_bar').css("width", '100%', function() {
                        return $(this).attr("aria-valuenow", 100) + "%";
                    });
                    return;
                }
            });
        });

        $("#CompareAudioForm").submit(function(e){
            e.preventDefault();
            let data = $(this).serialize();
            $('#CompareResultDiv').html('');
            $(".loaderContainer").show();
            $.ajax({
                url: "{{route('compare.save.file.data')}}",
                method:'POST',
                data: data,
                beforeSend:function(){
                    $('#GetSplittedAudioBtnSpan').html('Please wait...');
                    $("#GetSplittedAudioBtn").attr('disabled','disabled');
                },
                success:function(data){
                    // console.log(data);
                    $(".loaderContainer").hide();
                    $("#GetSplittedAudioBtn").removeAttr('disabled');
                    $('#GetSplittedAudioBtnSpan').text('Compare');
                    $('#CompareResultDiv').html(data);
                }
            });
        });
    });
  </script>
@endsection