@extends('app')
@section('content')
<link rel="stylesheet" type="text/css" href="{{asset('assets/vendor/audio/css/green-audio-player.css')}}">
<script src="{{asset('assets/vendor/audio/js/green-audio-player.js')}}"></script> 
<div class="section">
    <h2 class="fs-24 tss-m-sbold">Dashboard</h2>
    <div class="row">
        <div class="col-lg-4">
            <a href="" class="dashboard-box">
                <div class="boxed p-4 bg-white h-100">
                    <p class="fs-16 tss-m-medium">Number of Audios</p>
                    <div class="counter">
                        <span class="number">{{$data->uploadSplitAudio ?? '00'}}</span>
                        <span class="arrow"><i class="fa fa-arrow-right"></i></span>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-lg-4">
            <a href="" class="dashboard-box">
                <div class="boxed p-4 bg-white h-100">
                    <p class="fs-16 tss-m-medium">Number of Matched</p>
                    <div class="counter">
                        <span class="number">{{$data->MatchedCompareAudioscount ?? '00'}}</span>
                        <span class="arrow"><i class="fa fa-arrow-right"></i></span>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-lg-4">
            <a href="" class="dashboard-box">
                <div class="boxed p-4 bg-white h-100">
                    <p class="fs-16 tss-m-medium">How many Compared this Week?</p>
                    <div class="counter">
                        <span class="number">{{$data->CompareAudiosInWeek ?? '00'}}</span>
                        <span class="arrow"><i class="fa fa-arrow-right"></i></span>
                    </div>
                </div>
            </a>
        </div>
    </div>
</div>

<div class="section mt-5">
    <h2 class="fs-20 tss-m-sbold text-gray">Recent Searches</h2>
    <div class="row">
        <div class="col-12">
            <div class="boxed p-4 pb-5 bg-white h-100">
                <?php //echo "<pre>"; print_r($recentsearchs); echo "</pre>"; ?>
                <table class="table table-striped tss-table">
                    <thead>
                        <tr>
                            <th scope="col">Name</th>
                            <th scope="col" class="text-center">Email/Unique ID</th>
                            <th scope="col" class="text-center">Matched Percentage</th>
                            <th scope="col" class="">Audio File</th>
                            <th scope="col" class="">Download</th>
                        </tr>
                    </thead>
                    <tbody>
                        @if(count($recentsearchs) > 0)
                            @foreach($recentsearchs as $key => $recentsearch)
                                <tr>
                                    <td>{{$recentsearch->other_matched_name}}</td>
                                    <td class="text-center">{{$recentsearch->other_matched_email}}</td>    
                                    <td class="text-center"><span class="btn btn-outline-primary">{{$recentsearch->other_matched_percentage}}</span></td>
                                    <td class="">
                                        <div class="ready-player-1 player">
                                            <audio crossorigin>
                                                <source src="{{DefaultHelper::file_exists(asset($recentsearch->other_matched_audio))}}" type="audio/mpeg">
                                            </audio>
                                        </div>
                                    </td>
                                    <td>
                                        @php($filedownload = DefaultHelper::file_exists(asset($recentsearch->other_matched_audio)))
                                        <a href="javascript:0;" onclick="download_file('{{$filedownload}}', '{{$recentsearch->other_matched_name}}');" target="_blank" class="download_btn"><i class="fa fa-download"></i> Download</a>  
                                    </td>
                                </tr>
                            @endforeach
                        @else
                            <tr>
                                <td colspan="5">
                                    <div class="col-lg-12 p-2 text-center">
                                        <h4 class="fs-20 tss-m-bold mb-0">
                                            <span class="text-red">Sorry,</span> No Search results found!
                                        </h4>
                                    </div>
                                </td>
                            </tr>
                        @endif
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
<script>
    document.addEventListener('DOMContentLoaded', function() {
        GreenAudioPlayer.init({
            selector: '.player',
            stopOthersOnPlay: true
        });

        GreenAudioPlayer.init({
            selector: '.player-with-download',
            stopOthersOnPlay: true,
            showDownloadButton: true,
            enableKeystrokes: true
        });

        GreenAudioPlayer.init({
            selector: '.player-with-accessibility',
            stopOthersOnPlay: true,
            enableKeystrokes: true
        });
    });
</script>
@stop
