<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\VoiceController;
use App\Http\Controllers\AuthController;

Route::get('/cache-clear', function() {
    $image_path = __DIR__."/bootstrap/cache/config.php";
    if(file_exists($image_path)) {
        try{
            unlink($image_path);
        }catch(Exception $e) {
                        
        }                        
    }
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return "Cache is cleared";
});

Route::get('/route-cache', function() {
    Artisan::call('route:clear');
    return "config is cleared";
});


Route::get('/', [AuthController::class, 'login']);
Route::get('login', [AuthController::class, 'login'])->name('login');
Route::post('authentication', [AuthController::class, 'authentication']);
Route::get('logout', [AuthController::class, 'signOut'])->name('logout');

// Route::middleware(['auth_session'])->group(function () {});


Route::group([
    // 'prefix' => 'user',
    'middleware' => 'auth'
], function() {
    Route::get('dashboard', [VoiceController::class, 'dashboard'])->name('dashboard');

    Route::get('audio-listing', [VoiceController::class, 'audioListing'])->name('audio.listing');
    Route::get('audio-listing/data', [VoiceController::class, 'audioListingData'])->name('audio.listing.data');

    Route::get('compare', [VoiceController::class, 'compare'])->name('compare');
    Route::post('compare/save-file', [VoiceController::class, 'compareSaveFile'])->name('compare.save.file');
    Route::post('compare/save-file/data', [VoiceController::class, 'compareSaveFileData'])->name('compare.save.file.data');

    Route::get('split-audio', [VoiceController::class, 'splitAudio'])->name('split.audio');
    Route::post('split-audio/save-file', [VoiceController::class, 'splitAudioSaveFile'])->name('split.audio.save.file');
    Route::post('split-audio/save-file/data', [VoiceController::class, 'splitAudioSaveFileData'])->name('split.audio.save.file.data');
    Route::post('split-audio/result/save-data', [VoiceController::class, 'splitAudioResultSaveData'])->name('split.audio.result.save.data');

});

